/*
 * Wii Classic Controller for Arduino 
 * 
 */
#ifndef WiiClassicController_H
#define WiiClassicController_H

#include <Arduino.h>

class WiiClassicController
{
  public:
    uint8_t analogLX; // Left Side Anarog Stick X  - 6Bit
    uint8_t analogLY; // Left Side Anarog Stick Y  - 6Bit
    uint8_t analogRX; // Right Side Anarog Stick X - 5Bit
    uint8_t analogRY; // Right Side Anarog Stick Y - 5Bit
    uint8_t analogLB; // Left Side Anarog Buttob   - 5Bit
    uint8_t analogRB; // Right Side Anarog Button  - 5Bit
    uint16_t pushButton ;

    void init();
    void scan();

    inline bool isLeft() { return pushButton & 0b0000001000000000 ;}  // PAD LEFT
    inline bool isRight(){ return pushButton & 0b0000000010000000 ;}  // PAD RIGHT
    inline bool isUp()   { return pushButton & 0b0000000100000000 ;}  // PAD UP
    inline bool isDown() { return pushButton & 0b0000000001000000 ;}  // PAD DOWN
    inline bool isLBtn() { return pushButton & 0b0000000000100000 ;}  // BUTTON L
    inline bool isRBtn() { return pushButton & 0b0000000000000010 ;}  // BUTTON R
    inline bool isZLBtn(){ return pushButton & 0b1000000000000000 ;}  // BUTTON ZL
    inline bool isZRBtn(){ return pushButton & 0b0000010000000000 ;}  // BUTTON ZR  
    inline bool isSelectBtn(){ return pushButton & 0b0000000000010000 ;} // BUTTON -
    inline bool isHomeBtn()  { return pushButton & 0b0000000000001000 ;} // BUTTON HOME
    inline bool isStartBtn() { return pushButton & 0b0000000000000100 ;} // BUTTON +
    inline bool isXBtn() { return pushButton & 0b0000100000000000 ;} // BUTTON X
    inline bool isYBtn() { return pushButton & 0b0010000000000000 ;} // BUTTON Y
    inline bool isABtn() { return pushButton & 0b0001000000000000 ;} // BUTTON a
    inline bool isBBtn() { return pushButton & 0b0100000000000000 ;} // BUTTON b
  private:
    uint8_t values[8] ;

    void writeReadyCheck(); 
    void sendByte(byte data, byte location);
};
#endif
