#include <Wire.h>
#include "WiiClassicController.h"

#define BAUDRATE 9600
char str[128] ;

uint8_t RX,RY,LX,LY,BL,BR ;
uint16_t BTN ;

WiiClassicController wiiCC ;

void setup() {
  Serial.begin(BAUDRATE);

  wiiCC.init( ) ;
}

void loop() {
  wiiCC.scan( ) ;
  if (LX != wiiCC.analogLX || LY != wiiCC.analogLY || 
      RX != wiiCC.analogRY || RY != wiiCC.analogRY || 
      BL != wiiCC.analogLB || BR != wiiCC.analogLB || BTN != wiiCC.pushButton) {
    LX = wiiCC.analogLX ;
    LY = wiiCC.analogLY ; 
    RX = wiiCC.analogRX ;
    RY = wiiCC.analogRY ;
    BL = wiiCC.analogLB ;
    BR = wiiCC.analogRB ;
    BTN = wiiCC.pushButton ;

    sprintf(str,"L:%3d,%3d R:%3d,%3d B:%3d,%3d B:%04X ",LX,LY,RX,RY,BL,BR,BTN) ;
    Serial.print(str);

    if (wiiCC.isLeft()) { Serial.print("← "); }
    if (wiiCC.isRight()){ Serial.print("→ "); }
    if (wiiCC.isUp())   { Serial.print("↑ "); }
    if (wiiCC.isDown()) { Serial.print("↓ "); }
    if (wiiCC.isLBtn()) { Serial.print("LB "); }
    if (wiiCC.isRBtn()) { Serial.print("RB "); }
    if (wiiCC.isZLBtn()) { Serial.print("ZL "); }
    if (wiiCC.isZRBtn()) { Serial.print("ZR "); }
    if (wiiCC.isSelectBtn()) { Serial.print("- "); }
    if (wiiCC.isHomeBtn()) { Serial.print("HOME "); }
    if (wiiCC.isStartBtn()) { Serial.print("+ "); }
    if (wiiCC.isXBtn()) { Serial.print("X "); }
    if (wiiCC.isYBtn()) { Serial.print("Y "); }
    if (wiiCC.isABtn()) { Serial.print("a "); }
    if (wiiCC.isBBtn()) { Serial.print("b "); }
    Serial.println() ;
  }
}
